/*
/----------------------start-----------------------/
	数据库操作封装--带有数据源的DB
/-----------------------end---------------------/
*/

	var DBUtil={
		DBname:"care.db",//数据库名称
		DBPath:"fs://database/care.db",//数据库的fs路径
		dirPath:"fs://database",//数库的fs文件夹
		DBoldPath:"wgt://care.db",//数据库wgt地址
		isOpened:false,//数据库是否已打开
		version:"0.3.6",//当前数据库版本
		/**
			判断数据库是否存在
			@param:DBPath[string]--数据库文件路径
			@return: true/false[Boolean]--返回成功（true）或失败（false）
		*/
		existDB:function(callback){
			var flag=false;
			fileMgr.exist({
					    path: this.DBPath
					},callback);
			
		},
		/**
			创建datebase文件夹
			@param:dirPath[string]--需要创建的文件路径
			@return: true/false[Boolean]--返回成功（true）或失败（false）
		*/
		createDir:	function (callback){
			fileMgr.createDir({
					    path: this.dirPath
					}, callback);
		},
		/**
			copy数据库文件
			@param:DBoldPath[string]--copy源文件地址
			@param:DBnewPath[string]--copy目标文件地址
			@return: true/false[Boolean]--返回成功（true）或失败（false）
		*/
		copyDB:	function (callback){
			fileMgr.copy({
			    oldPath: this.DBoldPath,
			    newPath: this.dirPath
			},callback);
		},

		/**
			数据库打开成功
			@param:DBname[string]--数据库名称
			@param:DBpath[string]--数据库文件路径
			@return: true/false[Boolean]--返回成功（true）或失败（false）
		*/
		openData:function (callback){
			var	defalutFunc=function(ret, err){
					    if(ret.status){
					       console.log("数据库打开成功");
					       DBUtil.isOpened = true;
					    }else{
					       console.log("openDatabase:"+JSON.stringify( err ));
					    }
					}
					console.log("执行打开数据库的语句");
				md.openDatabase({
					    name: this.DBname,
					    path: this.dirPath
					}, callback||defalutFunc);

				
		},
		/**
			根据executeSql进行表查询
			@param:DBname[string]--执行的sql语句的数据库名称
			@param:querySql[string]--执行的sql语句
			@return: data[JSON]--查询出的数据
		*/
		queryCodeBySQL:function (querySql,callback){
				console.log(querySql);
				md.selectSql({
				    name: this.DBname,
				    path:this.dirPath,
				    sql: querySql
				},callback);
		},

		/**
			根据executeSql进行表查询
			@param:DBname[string]--执行的sql语句的数据库名称
			@param:querySql[string]--执行的sql语句
			@return: data[JSON]--查询出的数据
		*/
		queryCodeByTag:function (dictCode,callback){
			//var querySql = "select AAA100 as aaa100,AAA101 as aaa101,AAA102 as aaa102,AAA103 as aaa103,AAA104 as aaa104,YAB003 as yab003,AAE120 as aae120 from zhaa10 where AAA100='"+aaa100+"' and AAE120 = '1' order by AAA104";
			//var querySql = "select dictCode,dicName,code,codeVal from dataDictA where dictCode='"+dictCode+"' order by dicSn";
			var querySql = "select dictCode as aaa100,dictName as aaa101,code as aaa102,codeVal as aaa103 from dataDictA where dictCode='"+dictCode+"' and valiFlag=1 order by code";
				md.selectSql({
				    name: this.DBname,
				    path:this.dirPath,
				    sql: querySql
				},callback);
		},

		queryValueByCodeNew :function(Code,value){
			var querySql = "select codeVal as codeVal from dataDictA where dictCode='"+Code+"' and code = '"+value;
			console.log(querySql);
				md.selectSql({
				    name: this.DBname,
				    path:this.dirPath,
				    sql: querySql
				},function(ret, err){
					if(ret){
						return ret.data;
					}else{
						return "";
					}
				});
		},

		/**	执行sql语句//建表之类的语句
			@param:executeSql[string]--执行的sql语句
			@param:DBname[string]--执行的sql语句的数据库名称
		*/
		executeSQL:function (executeSql,callback){
			md.executeSql({
			    name: this.DBname,
			    path:this.dirPath,
			    sql: executeSql   
			},callback);
			console.log(callback);
		},

		/**
			关闭数据库
			@param:executeSql[string]--执行的sql语句
			@return: true/false[Boolean]--返回成功（true）或失败（false）
		*/

		closeDatabase:function (){
			     md.closeDatabase({
					    name:this.DBname
					}, function(ret, err){
					    if(ret.status){
					       console.log("关闭数据库完成");
					       this.isOpened = false;
					    }else{
					        console.log(JSON.stringify( err ));
					    }
					});
		},
		/**
			查询评估表数据
		*/
		queryTableCode:function(table,callback){
			
			var querySql = "select ZHE001 AS  zhe001,ZHE002  AS zhe002,ZHE003  AS zhe003,ZHE004  AS zhe004,ZHE005 AS  zhe005,ZHE006  AS zhe006,ZHE007  AS zhe007, ZHE008 AS  zhe008, ZHE009  AS zhe009,ZHE010  AS zhe010, ZHE011 AS  zhe011, AAE100 from zhe01 where AAE100 = '1' AND ZHE010 = '"+table+"' order by zhe002,zhe006"
			console.log(querySql);
				md.selectSql({
				    name: this.DBname,
				    path:this.dirPath,
				    sql: querySql
				},function(ret, err){
					
					    if(ret){
					       //组装数据
					       var data_prarms=[];
					       var data = ret.data;
					       var item={};
					       //组装父节点
					       var len = data.length;
					       for (var i = 0; i < len; i++) {
					       	var fatherData={}; 
					       		item=data[i];
					       		if(item.zhe002=="0"){
					       			//父级条目
					       			fatherData["id"]=item.zhe001;
					       			fatherData["name"]=item.zhe004;
					       			fatherData["desc"]=item.zhe009;
					       			fatherData["items"]=[];
					       			data_prarms.push(fatherData);

					       		}
					       		
					       }
					       //组装父节点里的数据
					        for (var i = 0; i < len; i++) {
					       		item=data[i];
					       		if(item.zhe002=="0"){
					       			//父级条目
					       			continue;
					       		}
					       		for (var key in data_prarms) {
					       			if(data_prarms[key].id == item.zhe002){
					       				data_prarms[key].items.push(item);
					       			}
					       		}
					       }					      
					       callback(data_prarms);
					    }else{
					       callback();
					       console.log("查询错误:"+JSON.stringify( err ));
					    }
					});
		}, 
		
		/**
			查询ADAS表中的父节点
		*/
		queryADAS :function(callback){
			var querySql = "select ZHE001 AS  zhe001,ZHE002  AS zhe002,ZHE003  AS zhe003,ZHE004  AS zhe004,ZHE005 AS  zhe005,ZHE006  AS zhe006,ZHE007  AS zhe007, ZHE008 AS  zhe008, ZHE009  AS zhe009, ZHE011 AS  zhe011 ,ZHE013 AS  zhe013 from zhe02 where zhe003='0' and AAE100 = '1' order by zhe013";
			console.log(querySql);
				md.selectSql({
				    name: this.DBname,
				    path:this.dirPath,
				    sql: querySql
				},function(ret, err){
					if(ret){
						callback(ret.data);
						console.log("data:"+JSON.stringify( ret ));
					}else{
						callback();
						console.log("查询错误:"+JSON.stringify( err ));
					}
				});
		},
		/**
			查询ADAS表中的子节点
		*/
		queryADASSub :function(callback){
			var querySql = "select ZHE001 AS  zhe001,ZHE002  AS zhe002,ZHE003  AS zhe003,ZHE004  AS zhe004,ZHE005 AS  zhe005,ZHE006  AS zhe006,ZHE007  AS zhe007, ZHE008 AS  zhe008, ZHE009  AS zhe009, ZHE011 AS  zhe011 ,ZHE013 AS  zhe013 from zhe02 where zhe003='1' and AAE100 = '1' order by zhe002,zhe006";
			console.log(querySql);
				md.selectSql({
				    name: this.DBname,
				    path:this.dirPath,
				    sql: querySql
				},function(ret, err){
					if(ret){
						callback(ret.data);
						console.log("data:"+JSON.stringify( ret ));
					}else{
						callback();
						console.log("查询错误:"+JSON.stringify( err ));
					}
				});
		},
		/**
			根据码值获取对应的中文值
		*/
		queryValueByCode :function(Code,value){
			var querySql = "select AAA100 as aaa100,AAA103 as aaa103 from zhaa10 where AAA100='"+Code+"' and aaa102 = '"+value+"' and AAE120 = '1' "  ;
			console.log(querySql);
				md.selectSql({
				    name: this.DBname,
				    path:this.dirPath,
				    sql: querySql
				},function(ret, err){
					if(ret){
						return ret.data;
					}else{
						return "";
					}
				});
		},
		queryValuesByCode :function(Code,callback){
			var querySql = "select AAA102 as aaa102,AAA103 as aaa103 from zhaa10 where AAA100='"+Code+"' and aae120 = '1'";
			console.log(querySql);
				md.selectSql({
				    name: this.DBname,
				    path:this.dirPath,
				    sql: querySql
				},function(ret, err){
					if(ret){
						callback(ret.data);
					}else{
						return "";
					}
				});
		},
		/*查询数据库更新时间*/
		queryUpdateTime:function(callback){
			var sql='select version,update_time from version';
			md.selectSql({
				    name: this.DBname,
				    path:this.dirPath,
				    sql: sql
				},callback);
		},

		/*根据参数查询对应行政区划*/
		queryAddressCode:function(aaa202,callback){
			var querySql = "SELECT aaa200,aaa201,aaa203,aaa204 FROM ZHAA11 where   AAA202 = '"+aaa202+"' AND AAE100 = '1'";
				md.selectSql({
				    name: this.DBname,
				    path:this.dirPath,
				    sql: querySql
				},function(ret, err){
					if(ret){
						callback(ret.data);
					}else{
						return "";
					}
				});
		},
		/*查询失能自评表*/
		queryEvalDisable:function(callback){
			//var querySql = "SELECT aaa100 as AAA100,AAA101 as AAA101,aaa102 as AAA102,aaa103 as AAA103,aaa104 as AAA104,aae120 as AAE120,ver as VER,yab003 as YAB003 FROM ZHAA10 WHERE AAA100 in ('ZAL101','ZAL102','ZAL103','ZAL104','ZAL105','ZAL106') AND AAE120 = '1'";
			var querySql = "SELECT dictCode as AAA100,dictName as AAA101,code as AAA102,codeVal as AAA103 FROM dataDictA WHERE dictCode in ('EATE_FOOD','PUT_CLOTHES','DEFECATION_CTRL','TOILET','WASH','BED_TRANS') and valiFlag=1";
				md.selectSql({
				    name: this.DBname,
				    path:this.dirPath,
				    sql: querySql
				},function(ret, err){
					if(ret){
						var data = ret.data,
							dataInfo = [];
						//console.log(JSON.stringify(data));
					    for(var i=0,len = data.length;i<len;i++){
					        if(i==0 || data[i-1]["AAA100"]!=data[i]["AAA100"]){
					            if(i!=0){
					                dataInfo.push(dataItem);
					            }
					            var dataItem = {};
					            dataItem["AAA100"] = data[i]["AAA100"];
					            dataItem["AAA101"] = data[i]["AAA101"];  
					            dataItem["items"] = [];
					        }
					        if(dataItem["AAA100"] == data[i]["AAA100"]){
					            dataItem["items"].push(data[i]);
					        }
					        if(i == len-1){
					        	dataInfo.push(dataItem);
					        }
					    }
					    //console.log(JSON.stringify(dataInfo));
						callback(dataInfo);
					}else{
						return "";
					}
				});
		},
		
		/*查询失智自评表*/
		queryFoolishable:function(callback){
			var querySql = "SELECT aaa100 as AAA100,AAA101 as AAA101,aaa102 as AAA102,aaa103 as AAA103,aaa104 as AAA104,aae120 as AAE120,ver as VER,yab003 as YAB003 FROM ZHAA10 WHERE AAA100 in ('ZAL302','ZAL303','ZAL304','ZAL305','ZAL306','ZAL307','ZAL308','ZAL309') AND AAE120 = '1'";
				md.selectSql({
				    name: this.DBname,
				    path:this.dirPath,
				    sql: querySql
				},function(ret, err){
					if(ret){
						var data = ret.data,
							dataInfo = [];
						console.log(JSON.stringify(data));
					    for(var i=0,len = data.length;i<len;i++){
					        if(i==0 || data[i-1]["AAA100"]!=data[i]["AAA100"]){
					            if(i!=0){
					                dataInfo.push(dataItem);
					            }
					            var dataItem = {};
					            dataItem["AAA100"] = data[i]["AAA100"];
					            dataItem["AAA101"] = data[i]["AAA101"];  
					            dataItem["items"] = [];
					        }
					        if(dataItem["AAA100"] == data[i]["AAA100"]){
					            dataItem["items"].push(data[i]);
					        }
					        if(i == len-1){
					        	dataInfo.push(dataItem);
					        }
					    }
					    console.log(JSON.stringify(dataInfo));
						callback(dataInfo);
					}else{
						return "";
					}
				});
		},

		/**
			数据库版本检查
			@param:executeSql[string]--执行的sql语句
			@return: true/false[Boolean]--返回成功（true）或失败（false）
		*/
		checkVersion:function(){

			DBUtil.openData(function(ret, err){
					    if(ret.status){
					       console.log("数据库打开成功");
					       DBUtil.isOpened = true;
					       var sql='select version from version';
			DBUtil.queryCodeBySQL(sql,function( ret, err ){ 
					if(ret){	
						//关闭数据库删除文件
						console.log("版本查询执行成功");
						//判断版本
						var DbVersion=ret.data[0].version;
						var AppDBversion=DBUtil.version;
						console.log("数据库版本ide："+AppDBversion);
						console.log("数据库版本db："+DbVersion);
						if(DbVersion!=AppDBversion){
							//更新数据库之前先删除这个关闭该数据库
							DBUtil.closeDatabase();
							//数据库版本与最新版本不一致，删除数据库文件
							fileMgr.remove({
							    path: DBUtil.DBPath
							}, function(ret, err){      
							    if( ret.status ){
							       //删除文件成功，copy文件
							        DBUtil.copyDB(
								         	function(ret, err){      
											    if( ret.status ){
											  		console.log("copy成功");
											  		DBUtil.openData();
											    }else{
											    	console.log("copyDB:"+JSON.stringify( err ) );
											    }
											});

							    }else{
							    	console.log(JSON.stringify( err ));
							    }
							});
						}else{
							console.log("已是最新数据库");
							
						}

				    }else{
				    	 $.toast({
						      msg:JSON.stringify( err ),
						});
						console.log("执行失败");
					}

			});

					    }else{
					       console.log("openDatabase:"+JSON.stringify( err ));
					    }
					});
			
		},

		/**
			初始化带有数据源的数据
		*/
		initDB:function(){
			 console.log("-----");
			DBUtil.existDB(
				function(ret,err){
					    if( ret.exist ){
					    	//存在文件
				        
				         console.log("-----");
				         DBUtil.checkVersion();
					    }else{
				       		console.log("existDB:"+JSON.stringify( err ) );
				       		DBUtil.createDir(
				       			function(ret, err){     
								    if( ret.status ){
								         console.log("-----创建datebase文件夹");
								         //创建成功copy文件
								         DBUtil.copyDB(
								         	function(ret, err){      
											    if( ret.status ){
											  		console.log("copy成功");
											  		 DBUtil.openData();
											    }else{
											    	console.log("copyDB:"+JSON.stringify( err ) );
											    }
											});
								    }else{
								        console.log("createDir:"+JSON.stringify( err ) );
								    }
								}
				       			);
					    }
					});
		},

	}
		
	
		
	
		
		



					
