
(function($) {
	if (typeof Base == "undefined") {
		Base = {};
		window.Base = Base;
	}
	$.extend(Base, {
		// "ctxPath": "/cdsim/",
		// "serverPath" : "http://192.168.3.10:8093/engine/rest/",   // 本地
		//"serverPath" : "http://42.123.92.185:8093/engine/rest/",  // 测试服务器
		"serverPath" : "http://42.123.92.185:9000/engine/rest/",   // 正式服务器
		// "serverPath" : "http://192.168.43.62:8093/engine/rest/",   // 本地
		// "serverPath" : "http://192.168.4.160:8093/engine/rest/", 
		"staticsPath": "statics/",
		"serverType": "callBusiness",
		"requestCount": 3
	});
	Base.REQUEST_CODE = {
		SUCC: '0',
		FAIL: '-1',
		LOSE_TOKEN: '403'
	}
	// 接口地址
	Base.requesetServerUrlPath = {
		"queryCode": "ta404/api/commonApiService/getCode", //查询码值
		"listApplyHistories": "ta404/api/psnApplyService/listApplyHistories", //申请记录查询
		"listApplyStatus": "ta404/api/psnApplyService/listApplyStatus", //申请进度查询
		"getApplyInfo": "ta404/api/psnApplyService/getApplyInfo", //查询申请信息
		"apply": "ta404/api/psnApplyService/apply", //失能申请
		"loginPsnDis": "ta404/api/commonApiService/login", //登录
		"checkApply": "ta404/api/psnApplyService/checkApply", //申请前检查
		"listApplyFiles": "ta404/api/psnApplyService/listApplyFiles", //查询附件
		"selectOrder": "ta404/api/nurseOrderService/selectOrder", // 查询照护订单
		"selectDisaPlan": "ta404/api/nursePlanService/selectDisaPlan", // 查询照护计划
		"selectNurseOrderByDisa": "ta404/api/nurseOrderService/selectNurseOrderByDisa", // 查询服务确认
		"saveServeAffirm": "ta404/api/nurseOrderService/saveServeAffirm", // 点击确认服务
		"assessConslusionQuery": "ta404/api/psnDisService/assessConslusionQuery", //评定结果查询
		"updateApplyInfo": "ta404/api/psnApplyService/updateApplyInfo", //修改申请信息
		"selectNurseChoose":"ta404/api/nursePlanService/selectNurseChoose", // 照护方式
		"selectCompleteOrder": "ta404/api/nurseOrderService/selectCompleteOrder", // 服务评价列表
		"updateAppraise": "ta404/api/nurseOrderService/updateAppraise", // 评价
		"selectDisaOrder": "ta404/api/nurseOrderService/selectDisaOrder",
		"getPublicDList":"ta404/api/othermanageService/getPublicDList",//查询通知公告列表
		"getPublicDById":"ta404/api/othermanageService/getPublicDById",//查询通知公告详情
	}

	Base.callBusinessUrlPath = {
		"queryCode": "D01001", //查询码值
		"listApplyHistories": "D01002", //申请记录查询
		"listApplyStatus": "D01003", //申请进度查询
		"getApplyInfo": "D01004", //查询申请信息
		"apply": "D01005", //失能申请
		"loginPsnDis": "L01001", //登录
		"checkApply": "D01006", //申请前检查
		"listApplyFiles": "D01007", //查询附件
		"selectOrder": "D01008", // 查询照护订单
		"selectDisaPlan": "D01009", // 查询照护计划
		"selectNurseOrderByDisa": "D01010", // 查询服务确认
		"saveServeAffirm": "D01011", // 点击确认服务
		"assessConslusionQuery": "D01012", //评定结果查询
		"updateApplyInfo": "D01013", //修改申请信息
		"selectNurseChoose":"D01014", // 照护方式
		"selectCompleteOrder": "D01015", // 服务评价列表
		"updateAppraise": "D01016", // 评价
		"selectDisaOrder": "D01017",
		"getPublicDList": "C01012",//查询通知公告列表
		"getPublicDById": "C01013",//查询通知公告详情
		"C01015": "C01015", // 上传图片文件
		"D01018": "D01018",
		"D01019": "D01019",
		"D01020": "D01020",
		"D01021": "D01021",
		"L01004": "L01004",
		"L01003": "L01003",
		"L01002": "L01002",
		"L01005": "L01005",
		"L01008": "L01008",
		"L01010": "L01010", // 头像上传
		"C01018": "C01018",
		"C01021": "C01021",
		"getPublicDFile": "D01022",  //获取政策附件
		"addCpltD" : "C01019",  // 投诉建议
		"D01023":"D01023" // 复评申请
	}

	Base.ucm = {
		'sysid':"chxtest",
		'addrcode':"510100",
		'loginid':"developer",
		'busitype':"IMAGE",
		"url":'http://192.168.17.190:9001/cloudstore/ucm/ucmAction!postFile.do'
	}

	Base.RLSB_config = {
		'nmservice': {name:'nmservice', url: '192.168.3.23:9090'},
		'hlfaceapi': {name:'hlfaceapi', url: '223.93.147.251:49090'}
	}
	Base.RLSB = {
		name: Base.RLSB_config.hlfaceapi.name,
		url: Base.RLSB_config.hlfaceapi.url,
		time: 8
	}

	Base.requestData = function(urlType, param, callback, mask, type) {
		var requestType = Base.serverType;
		if (requestType == 'callBusiness') {
			Base.callBusiness(urlType, param, callback, mask, type);
		} else if (requestType == 'requestServer') {
			Base.requestServerJson(urlType, param, callback, mask, type);
		}
	}

	/**
	 * 请求服务
	 * 
	 * @method requestServer
	 * @param {String}
	 *            urlType 根据类型取得服务器地址 必选
	 * @param {String}
	 *            data 请求参数对象 必选可为null，
	 * @param {String}
	 *            callback 回调方法 可选
	 * @param {Boolean}
	 *            mask 是否显示蒙层 可选 默认false
	 * @param {String}
	 *            type 请求方式:post,get 可选 默认post
	 */
	Base.requestServerJson = function(urlType, param, callback, mask, type) {
		urlType = Base.trim(urlType);
		var url = "";
		if (urlType.indexOf("http://") != -1) {
			url = urlType;
		} else {
			url = Base.serverPath + Base.requesetServerUrlPath[urlType];
		}
		param = Base.jsonToStr(param) || {};
		type = type || "post";
		var access_token = Base.getStorage("access_token");
		if (access_token == undefined) {
			access_token = "";
		}
		if (Base.isObject(param)) {
			param["access_token"] = access_token;
		}
		if (Base.isArray(param)) {
			param.push({
				"name" : "access_token",
				"value" : access_token
			});
		}
		if (mask) {
			Base.showGifMask();
		}
		console.log(url + "---" + param);
		var ajax = $.ajax({
			type : type,
			contentType : "application/json; charset=utf-8", // post提交乱码
			url : url,
			data : param,
			success : function(data) {
				console.log(urlType + "请求结果：" + JSON.stringify(data))
				Base.removeGifMask();
				if (typeof data == "string") {
					data = eval("(" + data + ")");
				}
				callback(data);
			},
			error : function(xhr, type) {
				Base.removeGifMask();
				console.log(JSON.stringify(xhr))
				md.toast({msg: '网络错误！'})
			}
		});
		return ajax;
	}

	Base.callBusiness = function(urlType, param, callback, mask, type) {
		urlType = Base.trim(urlType);
		var url = "";
		if (urlType.indexOf("http://") != -1) {
			url = urlType;
		} else {
			url = Base.serverPath + Base.callBusinessUrlPath[urlType];
		}
		param = param || {};
		
		type = type || "post";
		var access_token = Base.getStorage("access_token");
		var apiToken = Base.getStorage("apiToken");
		if (!access_token) {
			access_token = "";
		}

		if (!apiToken) {
			apiToken = ""
		}
		param.apiToken = apiToken;

		if (mask) {
			Base.showGifMask();
		}
		timestamp = new Date().getTime();
		var params = {};
		params.access_token = access_token;
		params.access_key = "disa_app";
        params.version = "1.0.0";
        params.timestamp = timestamp;
        params.biz_content = JSON.stringify(param).replace(/\"/g,"'");
		md.ajax({
            method: type,
            url: url,
            data: {
                values: params
            }
        }, function(ret, err) {
            console.log(urlType + '请求结果：' + JSON.stringify(ret))
            console.log('请求错误：' + JSON.stringify(err))
            Base.removeGifMask();
            if (ret && ret.body.biz_data) {
            	callback(ret.body.biz_data)
            } else {
            	// token失效处理
            	if (ret.body && ret.body.code == '-105') {
            		if (Base.requestCount <= 0) {
            			md.toast({msg: "APP运行出错，请联系维护人员！"})
            			return;
            		}
            		Base.getAccessToken(function(ret) {
            			Base.requestCount--
            			md.setPrefs({
			                key: 'access_token',
			                value: ret.body.access_token
			            });
			            md.setPrefs({
			                key: 'refresh_token',
			                value: ret.body.refresh_token
			            });
            			Base.callBusiness(urlType, param, callback, mask, type)
            		})
            	} else {
            		md.toast({
	            	    msg: '请求失败！',
	            	    duration: 2000,
	            	    location: 'middle'
	            	});
            	}
            }
        })
	}
    // 3.22 e32b5d7fe9d55695dbc6fbaccc3666e88425fe7cac226024dc1986cf52e86902
    // 本地 6cc99297f1114b89fc76c1ebf8f80580b4da6ab51ac1128945fa66f21110fe17
    // cs  3d09045f083386245d0789b2a0f9d19367abef3a6904338f76b1fc6219b67301
    // zs  8f6c940488387323450d2d26f6abee4d53b5948ea9eafaf805c681aa81441a04
    // h5cs58 6cdad7b8b5a0fb8f68c53c4ab735218390c425f6f6e8bf693ef2421d4b481efb
    // h5本地 0e90fff37645966710460cf8b7173eea465eb04880f2bdff76dc043917b5fded
	Base.getAccessToken = function(callback) {
		timestamp = new Date().getTime();
		var key = '8f6c940488387323450d2d26f6abee4d53b5948ea9eafaf805c681aa81441a04';
		var keyToken = '';
		Base.showGifMask();
		rsaEncrypt.encrypt({value: key}, function(ret,err){
		    if (ret) {
		        //inputString的value加密成功
		        keyToken = ret.value
		        md.ajax({
		            method: 'post',
		            url: Base.serverPath + 'request_token', // 192.168.21.115
		            data: {
		                values: {
		                	access_key: "disa_app",
		                	timestamp: timestamp,
		                	request_token: keyToken
		                }
		            }
		        }, function(ret, err) {
		        	console.log("token获取成功：" + ret);
		        	if (err) {
		        		console.log("token获取失败：" + err);
		        	}
		        	callback(ret);
		        });
		    } else {
		    	Base.removeGifMask();
		    	md.toast({
		    	    msg: '登录失败，未获取到令牌，请重新登录！',
		    	    duration: 2000,
		    	    location: 'middle'
		    	});
		    }
		});
	}

	Base.getRefreshToken = function(callback) {
		timestamp = new Date().getTime();
		md.ajax({
            method: 'post',
            url: Base.serverPath + 'refresh_token',
            data: {
                values: {
                	access_key: "disa_app",
                	timestamp: timestamp,
                	refresh_token: md.getPrefs({key: 'refresh_token'})
                }
            }
        }, function(ret, err) {
            console.log(JSON.stringify(ret))
            md.toast({
                msg: JSON.stringify(ret),
                duration: 2000,
                location: 'middle'
            });
            callback(ret)
            Base.removeGifMask();
        });
	}

	Base.Gend = {
		'1': '男',
		'2': '女'
	}

	//SDK返回值标准设置
	Base.SDK_Success=1;
	Base.SDK_Error=-1;
	//服务器请求返回
	Base.FW_Success=1;//请求服务成功
	Base.FW_Error=-1;//请求服务失败
	Base.FW_TiemOut=-2;//登录会话超时，重新登录
	/**
	 * 点击事件
	 * 
	 * @method click
	 * @param {string}
	 *            selector 必选 选择器
	 * @param {string}
	 *            act 可选 点击效果class: md-act1(背景色为#eee)、md-act2(点击缩小弹动效果)
	 * @param {function}
	 *            func 必须 回调方法， 接收两个参数1：点击当前元素$(this), 2: 点击事件状态e
	 */
	Base.click = function(selector, func, act) {
		var hasTouch = ('ontouchstart' in window);
		var className = act || "";
		if (className) {
			if (hasTouch) {
				$(document).on("touchstart", selector, function() {
					$(this).addClass(className);
				});
				$(document).on("touchend", selector, function() {
					$(this).removeClass(className);
				});
				$(document).on("touchcancel", selector, function() {
					$(this).removeClass(className);
				});
				$(document).on("touchmove", selector, function() {
					$(this).removeClass(className);
				});
			} else {
				$(document).on("mousedown", selector, function() {
					$(this).addClass(className);
				});
				$(document).on("mouseup", selector, function() {
					$(this).removeClass(className);
				});
			}
		}
		var eventName = "click";
		if(typeof mdui != "undefined" && "ontouchstart" in window) {
			eventName = "touchstart";
		}
		$(document).on(eventName, selector, function(e) {
			var $this = $(this);
			func($this, e);
		});
	}

	/**
	 * 显示gifMask
	 * 
	 * @method showGifMask
	 */
	Base.showGifMask = function(text) {
    		md.showProgress({
		        content: text,
		        modal: false
		    });
	}
	/**
	 * 移除gifMask（与showGifMask相对应）
	 * 
	 * @method removeGifMask
	 */
	 Base.removeGifMask = function() {
	    	md.hideProgress();
	}

	/*下拉刷新载更多 上拉插件初始化操作
	 * @method setHeader
	 * @param {Function}
	 *            callback 必选 下拉刷新回调
	 * @param {Object}
	 *            obj 可选  下拉刷新的属性对象
	 * @param {string}
	 *            obj.type 可选 刷新控件的类型(normal, gif)
	 * @param {Boolean}
	 *            obj.stateHidden 可选 刷新控件的文字是否隐藏
	 * @param {Array}
	 *            obj.stateLabels 可选 刷新控件的提示文字,数组中必须是三个值才能生效
	 * @param {string}
	 *            obj.stateColor 可选 此颜色值会运用在刷新控件文字,箭头,菊花颜色上
	 * @param {string}
	 *            obj.bgColor 可选 刷新控件的背景颜色
	*/
	//设置下拉刷新
	Base.setHeader = function(callback,obj){
		var objA = obj||{bgColor:'#eeedf2'};
		var func = callback;
		if(typeof func == 'function'){
			//传入的数据为function则进行下拉刷新注册
			pullRefresh.setHeader(objA,func);
		}
		
	}
	//设置上拉加载更多
	Base.setFooter = function(callback,obj){
		var objA = obj||{bgColor:'#eeedf2'};
		var func = callback;
		if(typeof func == 'function'){
			//传入的数据为function则进行下拉刷新注册
			pullRefresh.setFooter(objA,func);
		}
		
	}

	/*下拉刷新*/
	/**
	 * 信息提示()
	 * 
	 * @method toast
	 * @param {string}
	 *            msg 必选 提示信息
	 * @param {string}
	 *            time 可选 持续时长，单位：毫秒
	 * @param {string}
	 *            location 可选 弹出位置，顶部、中间或底部（top-顶部/middle-中间/bottom-底部
	 */
	Base.toast = function(msg, time, location) {
		var msgs = msg||"提示";
		var time = Number(time)||2000;
		var location = location||"middle";
		md.toast({
		    msg: msgs,
		    duration: time,
		    location: location
		});
	}
	/**
	 * 消息提示（轻）
	 * 
	 * @method msgTip
	 * @param {String}
	 *            msg 必选 提示内容
	 * @param {time:
	 *            持续时间, top: top, left: left, bottom: bottom, right: right} 可选
	 */
	Base.msgTip = function(msg, param) {
		if (arguments.length == 1) {
			param = {};
		}
		var _t = param["time"] || 2000;
		var style = "style='";
		var _top = param["top"];
		if (_top) {
			style += "top:" + _top + ";";
		}
		var _bottom = param["bottom"];
		if (_bottom) {
			style += "bottom:" + _bottom + ";";
		}
		var _left = param["left"];
		if (_left) {
			style += "left:" + _left + ";";
		}
		var _right = param["right"];
		if (_right) {
			style += "right:" + _right + ";";
		}
		style += "'";
		var $div = $("<div class=\"md-msgtip\" " + style
				+ "><div class='mm-msg'>" + msg + "</div></div>");
		$("body").append($div);
		setTimeout(function() {
			$div.remove();
		}, _t);
	}
	/**
	 * 创建上拉下拉刷新
	 * 
	 * @param {int}
	 *            type 0/不传： 上拉下拉刷新； 1：下拉刷新；2：上拉刷新
	 * @param {function}
	 *            down： 上拉回调方法
	 * @param {function}
	 *            up： 下拉回调方法
	 */
	Base.creatRefresh = function(type, down, up) {
		if (down == undefined) {
			down = function() {
				setTimeout(function() {
					Base.removeDown();
				}, 1000);
			};
		}
		if (up == undefined) {
			up = function() {
				setTimeout(function() {
					Base.removeUp();
				}, 1000);
			};
		}
		var top = $(".md-header").height() || 0;
		var paddingBottom = $(".md-footer").height() || 0;
		var d1 = ('<div id="pullrefresh" class="mdui-content mdui-scroll-wrapper" style="top: '
				+ top + 'px; padding-bottom: ' + paddingBottom + 'px;">' + '<div class="mdui-scroll"></div></div>');
		var min_height = $(window).height() - top - paddingBottom;
		$(".md-content").css("min-height", min_height+"px").wrap(d1);
		if (typeof mdui == "undefined") {
			Base.msgTip("未定义mdui");
			return false;
		}
		var pr = {
			pullRefresh : {
				container : '#pullrefresh',
			}
		}
		if (type == 1) {
			pr.pullRefresh.down = {
				callback : down
			}
		} else if (type == 2) {
			pr.pullRefresh.up = {
				contentrefresh : '正在加载...',
				callback : up
			}
		} else {
			pr.pullRefresh.down = {
				callback : down
			}
			pr.pullRefresh.up = {
				contentrefresh : '正在加载...',
				callback : up
			}
		}
		mdui.init(pr);
	}
	Base.removeDown = function() {
		mdui('#pullrefresh').pullRefresh().endPulldownToRefresh();
	}
	Base.removeUp = function() {
		mdui('#pullrefresh').pullRefresh().endPullupToRefresh();
	}
	// 获得参数
	Base.getParams = function() {
		var data = {};
		if (Base.isPC() === true) {
			var href = decodeURI(decodeURI(window.location.search.substring(1)));
			var arr = href.split("&");
			for (var i = 0; i < arr.length; i++) {
				var d = arr[i].split("=");
				data[d[0]] = d[1];
			}
		} else {
			var data = md.pageParam;
		}
		return data;
	}
	// 刷新页面
	Base.refreshWin = function() {
		window.location.reload();
	}
	/**
	 * 没有网络显示显示
	 */
	Base.noNetworkPage = function(selector) {
		var $n = $(selector);
		if (!$n[0]) {
			$n = $(".md-content");
		}
		var div = '' + '<div class="md-box md-ac md-pc md-ver md-f1">'
				+ '<div class="md-box no-img md-img"></div>'
				+ '<div class="md-box no-text1">网络错误找不到页面~~</div>'
				+ '<div class="md-box no-text2">点击屏幕重新尝试</div>' + '</div';
		$n.html(div);
	};
	/**
	 * 没有数据显示显示
	 */
	Base.noDataPage = function(selector, text) {
		var $n = $(selector);
		if (!$n[0]) {
			$n = $(".md-content");
		}
		if (text == undefined) {
			text = "无相关数据";
		}
		var div = '' + '<div class="md-box nodata_content md-ver md-ac md-pc">'
				+ '<div class="md-box nodata"></div>'
				+ '<div class="md-box nodata_text">' + text + '</div>' + '</div>';
		$n.html(div);
	};

		Base.isLogin=function(){
			var userid = md.getPrefs({key: 'userid'});
			if(userid){
				return true;
			}
			return false;
		};
		/*失能人员登录方法*/
		Base.toLogin = function(tag){
	        md.openFrame({
			    name: 'login',
			    url: 'wgt://disa/login/userlogin.html',
			    rect: {
			        y: 0
			    },
			    bounces:false
			});
		}
	/**
     * 打开window
     */
    Base.openWin = function(data){
    	 var slidBackEnabledType=true;
    	 if(!data.slidBackEnabled){
    	 	slidBackEnabledType = data.slidBackEnabled;
    	 }
        md.openWin({
            name: data.name, //window名字，不能为空字符串
            url: data.url, //页面地址
            animation :data.animation, //（可选项）动画参数，不传时使用默认动画（从右往左推入）
            bounces: data.bounces || false, //（可选项）页面是否弹动
            reload: data.reload, //是否重新加载页面
            slidBackEnabled:slidBackEnabledType,//是否支持滑动返回
            pageParam: {
                isRelavte : data.isRelavte, //相对布局方式
                frameName: data.frameName || "",
                frameUrl: data.frameUrl || "",
                title: data.title || "",
                bounces: data.bounces || false, //（可选项）页面是否弹动
                reload: data.reload, //是否重新加载页面
                bgColor: data.bgColor, //frame背景颜色
                framePageData: data.framePageData
            } //（可选项）页面参数，新页面中可以通过md.pageParam获取
        });
    } 
    /*
	绑定返回事件	
	*/
	$(document).on("click", ".back-icon", function() {
	           md.closeWin();      
	    });
}($));